Index: code/trunk/src/libraries/core/module/PluginManager.cc
===================================================================
--- code/trunk/src/libraries/core/module/PluginManager.cc	(revision 10624)
+++ code/trunk/src/libraries/core/module/PluginManager.cc	(revision 10624)
@@ -0,0 +1,134 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "PluginManager.h"
+
+#include <fstream>
+
+#include "SpecialConfig.h"
+#include "Plugin.h"
+#include "PluginReference.h"
+#include "core/ApplicationPaths.h"
+#include "core/command/ConsoleCommandIncludes.h"
+#include "core/object/Context.h"
+
+namespace orxonox
+{
+    static const std::string __CC_PluginManager_load_name  = "load";
+    static const std::string __CC_PluginManager_unload_name  = "unload";
+
+    SetConsoleCommand("PluginManager", __CC_PluginManager_load_name, &PluginManager::loadPlugin);
+    SetConsoleCommand("PluginManager", __CC_PluginManager_unload_name, &PluginManager::unloadPlugin);
+
+    PluginManager* PluginManager::singletonPtr_s  = 0;
+
+    PluginManager::PluginManager()
+    {
+        ModifyConsoleCommand("PluginManager", __CC_PluginManager_load_name).setObject(this);
+        ModifyConsoleCommand("PluginManager", __CC_PluginManager_unload_name).setObject(this);
+    }
+
+    PluginManager::~PluginManager()
+    {
+        ModifyConsoleCommand("PluginManager", __CC_PluginManager_load_name).setObject(NULL);
+        ModifyConsoleCommand("PluginManager", __CC_PluginManager_unload_name).setObject(NULL);
+
+        for (std::map<std::string, PluginReference*>::iterator it = this->references_.begin(); it != this->references_.end(); ++it)
+            delete it->second;
+        for (std::map<std::string, Plugin*>::iterator it = this->plugins_.begin(); it != this->plugins_.end(); ++it)
+            delete it->second;
+    }
+
+    void PluginManager::findPlugins()
+    {
+        const std::vector<std::string>& pluginPaths = ApplicationPaths::getInstance().getPluginPaths();
+        for (std::vector<std::string>::const_iterator it = pluginPaths.begin(); it != pluginPaths.end(); ++it)
+        {
+            std::string name;
+            std::string libraryName = (*it);
+            std::string filename = libraryName +  + specialConfig::pluginExtension;
+            std::ifstream infile(filename.c_str());
+            if (infile >> name)
+            {
+                orxout(internal_info) << "Found plugin with name '" << name << "' in module " << libraryName << endl;
+                this->plugins_[name] = new Plugin(name, libraryName);
+            }
+            else
+            {
+                orxout(internal_warning) << "Could not read plugin file " << filename << endl;
+            }
+        }
+    }
+
+    void PluginManager::referencePlugin(const std::string& name)
+    {
+        Plugin* plugin = this->plugins_[name];
+        if (plugin != NULL)
+            plugin->load();
+        else
+            orxout(internal_warning) << "Cannot find plugin with name " << name << endl;
+    }
+
+    void PluginManager::dereferencePlugin(const std::string& name)
+    {
+        Plugin* plugin = this->plugins_[name];
+        if (plugin != NULL)
+            plugin->unload();
+        else
+            orxout(internal_warning) << "Cannot find plugin with name " << name << endl;
+    }
+
+    /**
+     * @brief Console command to manually load a plugin. The plugin stays loaded until @ref unloadPlugin is called.
+     */
+    void PluginManager::loadPlugin(const std::string& name)
+    {
+        if (this->references_[name] == NULL)
+        {
+            this->references_[name] = new PluginReference(name);
+        }
+        else
+            orxout(internal_warning) << "Plugin " << name << " is already loaded" << endl;
+    }
+
+    /**
+     * @brief Console command to unload a plugin if it was previously loaded manually by calling @ref loadPlugin.
+     * Does not unload the plugin immediately if it is still used by another @ref PluginReference (e.g. by a @ref Level).
+     */
+    void PluginManager::unloadPlugin(const std::string& name)
+    {
+        PluginReference* reference = this->references_[name];
+        if (reference != NULL)
+        {
+            this->references_[name] = NULL;
+            delete reference;
+        }
+        else
+            orxout(internal_warning) << "Plugin " << name << " is already unloaded" << endl;
+    }
+}
Index: code/trunk/src/libraries/core/module/PluginManager.h
===================================================================
--- code/trunk/src/libraries/core/module/PluginManager.h	(revision 10624)
+++ code/trunk/src/libraries/core/module/PluginManager.h	(revision 10624)
@@ -0,0 +1,65 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _PluginManager_H__
+#define _PluginManager_H__
+
+#include "core/CorePrereqs.h"
+
+#include <map>
+#include <string>
+#include "util/Singleton.h"
+
+namespace orxonox
+{
+    class _CoreExport PluginManager : public Singleton<PluginManager>
+    {
+        friend class Singleton<PluginManager>;
+
+        public:
+            PluginManager();
+            ~PluginManager();
+
+            void findPlugins();
+
+            void referencePlugin(const std::string& name);
+            void dereferencePlugin(const std::string& name);
+
+            // console commands
+            void loadPlugin(const std::string& name);
+            void unloadPlugin(const std::string& name);
+
+        private:
+            std::map<std::string, Plugin*> plugins_;
+            std::map<std::string, PluginReference*> references_; // references that were created by console command
+
+            static PluginManager* singletonPtr_s;
+    };
+}
+
+#endif /* _PluginManager_H__ */
Index: code/trunk/src/libraries/core/module/PluginReference.cc
===================================================================
--- code/trunk/src/libraries/core/module/PluginReference.cc	(revision 10624)
+++ code/trunk/src/libraries/core/module/PluginReference.cc	(revision 10624)
@@ -0,0 +1,46 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "PluginReference.h"
+
+#include "PluginManager.h"
+
+namespace orxonox
+{
+    PluginReference::PluginReference(const std::string& name) : name_(name)
+    {
+        // load plugin
+        PluginManager::getInstance().referencePlugin(this->name_);
+    }
+
+    PluginReference::~PluginReference()
+    {
+        // unload plugin
+        PluginManager::getInstance().dereferencePlugin(this->name_);
+    }
+}
Index: code/trunk/src/libraries/core/module/PluginReference.h
===================================================================
--- code/trunk/src/libraries/core/module/PluginReference.h	(revision 10624)
+++ code/trunk/src/libraries/core/module/PluginReference.h	(revision 10624)
@@ -0,0 +1,49 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _PluginReference_H__
+#define _PluginReference_H__
+
+#include "core/CorePrereqs.h"
+
+#include "core/object/Destroyable.h"
+
+namespace orxonox
+{
+    class _CoreExport PluginReference : public Destroyable
+    {
+        public:
+            PluginReference(const std::string& name);
+            ~PluginReference();
+
+        private:
+            std::string name_;
+    };
+}
+
+#endif /* _PluginReference_H__ */
Index: code/trunk/src/libraries/core/module/StaticInitializationHandler.h
===================================================================
--- code/trunk/src/libraries/core/module/StaticInitializationHandler.h	(revision 10624)
+++ code/trunk/src/libraries/core/module/StaticInitializationHandler.h	(revision 10624)
@@ -0,0 +1,50 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _StaticInitializationHandler_H__
+#define _StaticInitializationHandler_H__
+
+#include "core/CorePrereqs.h"
+
+namespace orxonox
+{
+    class _CoreExport StaticInitializationHandler
+    {
+        public:
+            StaticInitializationHandler() {}
+            virtual ~StaticInitializationHandler() {}
+
+            virtual void setupHandler() = 0;
+            virtual void shutdownHandler() = 0;
+
+            virtual void loadModule(ModuleInstance* module) = 0;
+            virtual void unloadModule(ModuleInstance* module) = 0;
+    };
+}
+
+#endif /* _StaticInitializationHandler_H__ */
Index: code/trunk/src/libraries/core/module/StaticInitializationHandlerIncludes.cc
===================================================================
--- code/trunk/src/libraries/core/module/StaticInitializationHandlerIncludes.cc	(revision 10624)
+++ code/trunk/src/libraries/core/module/StaticInitializationHandlerIncludes.cc	(revision 10624)
@@ -0,0 +1,44 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "StaticInitializationHandlerIncludes.h"
+
+#include "StaticInitializationManager.h"
+
+namespace orxonox
+{
+    void StaticallyInitializedStaticInitializationHandler::load()
+    {
+        StaticInitializationManager::getInstance().addHandler(this->handler_);
+    }
+
+    void StaticallyInitializedStaticInitializationHandler::unload()
+    {
+        StaticInitializationManager::getInstance().removeHandler(this->handler_);
+    }
+}
Index: code/trunk/src/libraries/core/module/StaticInitializationHandlerIncludes.h
===================================================================
--- code/trunk/src/libraries/core/module/StaticInitializationHandlerIncludes.h	(revision 10624)
+++ code/trunk/src/libraries/core/module/StaticInitializationHandlerIncludes.h	(revision 10624)
@@ -0,0 +1,68 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _StaticInitializationHandlerIncludes_H__
+#define _StaticInitializationHandlerIncludes_H__
+
+#include "core/CorePrereqs.h"
+
+#include "StaticInitializationHandler.h"
+#include "StaticallyInitializedInstance.h"
+
+/**
+ * Registers a StaticInitializationHandler
+ */
+#define RegisterStaticInitializationHandler(className) \
+    static StaticInitializationHandler& className##StaticInitializationHandler \
+        = (new orxonox::SI_SIH(new className()))->getHandler()
+
+namespace orxonox
+{
+    class _CoreExport StaticallyInitializedStaticInitializationHandler : public StaticallyInitializedInstance
+    {
+        public:
+            StaticallyInitializedStaticInitializationHandler(StaticInitializationHandler* handler)
+                : StaticallyInitializedInstance(StaticInitialization::STATIC_INITIALIZATION_HANDLER)
+                , handler_(handler)
+            {}
+            ~StaticallyInitializedStaticInitializationHandler() { delete handler_; }
+
+            virtual void load();
+            virtual void unload();
+
+            inline StaticInitializationHandler& getHandler()
+                { return *this->handler_; }
+
+        private:
+            StaticInitializationHandler* handler_;
+    };
+
+    typedef StaticallyInitializedStaticInitializationHandler SI_SIH;
+}
+
+#endif /* _StaticInitializationHandlerIncludes_H__ */
Index: code/trunk/src/libraries/core/module/StaticInitializationManager.cc
===================================================================
--- code/trunk/src/libraries/core/module/StaticInitializationManager.cc	(revision 10624)
+++ code/trunk/src/libraries/core/module/StaticInitializationManager.cc	(revision 10624)
@@ -0,0 +1,63 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "StaticInitializationManager.h"
+
+#include "StaticInitializationHandler.h"
+
+namespace orxonox
+{
+    StaticInitializationManager* StaticInitializationManager::singletonPtr_s = 0;
+
+    void StaticInitializationManager::addHandler(StaticInitializationHandler* handler)
+    {
+        handler->setupHandler();
+        this->handlers_.push_back(handler);
+    }
+
+    void StaticInitializationManager::removeHandler(StaticInitializationHandler* handler)
+    {
+        this->handlers_.remove(handler);
+        handler->shutdownHandler();
+    }
+
+    void StaticInitializationManager::loadModule(ModuleInstance* module)
+    {
+        // attention: loading a module may add new handlers to the list
+        for (std::list<StaticInitializationHandler*>::iterator it = this->handlers_.begin(); it != this->handlers_.end(); ++it)
+            (*it)->loadModule(module);
+    }
+
+    void StaticInitializationManager::unloadModule(ModuleInstance* module)
+    {
+        // unload in reversed order
+        // attention: unloading a module may remove handlers from the list
+        for (std::list<StaticInitializationHandler*>::reverse_iterator it = this->handlers_.rbegin(); it != this->handlers_.rend(); )
+            (*(it++))->unloadModule(module);
+    }
+}
Index: code/trunk/src/libraries/core/module/StaticInitializationManager.h
===================================================================
--- code/trunk/src/libraries/core/module/StaticInitializationManager.h	(revision 10624)
+++ code/trunk/src/libraries/core/module/StaticInitializationManager.h	(revision 10624)
@@ -0,0 +1,61 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _StaticInitializationManager_H__
+#define _StaticInitializationManager_H__
+
+#include "core/CorePrereqs.h"
+
+#include <list>
+
+#include "util/Singleton.h"
+
+namespace orxonox
+{
+    class _CoreExport StaticInitializationManager : public Singleton<StaticInitializationManager>
+    {
+        friend class Singleton<StaticInitializationManager>;
+
+        public:
+            StaticInitializationManager() {}
+            virtual ~StaticInitializationManager() {}
+
+            void addHandler(StaticInitializationHandler* handler);
+            void removeHandler(StaticInitializationHandler* handler);
+
+            void loadModule(ModuleInstance* module);
+            void unloadModule(ModuleInstance* module);
+
+        private:
+            std::list<StaticInitializationHandler*> handlers_;
+
+            static StaticInitializationManager* singletonPtr_s;
+    };
+}
+
+#endif /* _StaticInitializationManager_H__ */
Index: code/trunk/src/libraries/core/module/StaticallyInitializedInstance.cc
===================================================================
--- code/trunk/src/libraries/core/module/StaticallyInitializedInstance.cc	(revision 10624)
+++ code/trunk/src/libraries/core/module/StaticallyInitializedInstance.cc	(revision 10624)
@@ -0,0 +1,46 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "StaticallyInitializedInstance.h"
+
+#include "ModuleInstance.h"
+
+namespace orxonox
+{
+    StaticallyInitializedInstance::StaticallyInitializedInstance(StaticInitialization::Type type)
+    {
+        this->type_ = type;
+        this->module_ = ModuleInstance::getCurrentModuleInstance();
+        this->module_->addStaticallyInitializedInstance(this);
+    }
+
+    StaticallyInitializedInstance::~StaticallyInitializedInstance()
+    {
+        this->module_->removeStaticallyInitializedInstance(this);
+    }
+}
Index: code/trunk/src/libraries/core/module/StaticallyInitializedInstance.h
===================================================================
--- code/trunk/src/libraries/core/module/StaticallyInitializedInstance.h	(revision 10624)
+++ code/trunk/src/libraries/core/module/StaticallyInitializedInstance.h	(revision 10624)
@@ -0,0 +1,55 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _StaticallyInitializedInstance_H__
+#define _StaticallyInitializedInstance_H__
+
+#include "core/CorePrereqs.h"
+
+namespace orxonox
+{
+    class _CoreExport StaticallyInitializedInstance
+    {
+        public:
+
+            StaticallyInitializedInstance(StaticInitialization::Type type);
+            virtual ~StaticallyInitializedInstance();
+
+            virtual void load() = 0;
+            virtual void unload() = 0;
+
+            inline StaticInitialization::Type getType() const
+                { return this->type_; }
+
+        private:
+            ModuleInstance* module_;
+            StaticInitialization::Type type_;
+    };
+}
+
+#endif /* _StaticallyInitializedInstance_H__ */
Index: code/trunk/src/libraries/core/object/CMakeLists.txt
===================================================================
--- code/trunk/src/libraries/core/object/CMakeLists.txt	(revision 10622)
+++ code/trunk/src/libraries/core/object/CMakeLists.txt	(revision 10624)
@@ -2,4 +2,5 @@
   Context.cc
   Destroyable.cc
+  DestroyLaterManager.cc
   Listable.cc
   ObjectListBase.cc
Index: code/trunk/src/libraries/core/object/Context.cc
===================================================================
--- code/trunk/src/libraries/core/object/Context.cc	(revision 10622)
+++ code/trunk/src/libraries/core/object/Context.cc	(revision 10624)
@@ -76,13 +76,16 @@
     /*static*/ void Context::setRootContext(Context* context)
     {
-        if (Context::rootContext_s)
-            delete Context::rootContext_s;
         Context::rootContext_s = context;
+    }
+
+    /*static*/ void Context::destroyRootContext()
+    {
+        delete Context::rootContext_s;
+        Context::rootContext_s = NULL;
     }
 
     /*static*/ Context* Context::getRootContext()
     {
-        if (!Context::rootContext_s)
-            Context::rootContext_s = new Context(NULL);
+        OrxVerify(Context::rootContext_s != NULL, "Root Context is undefined");
         return Context::rootContext_s;
     }
@@ -97,3 +100,10 @@
         return this->objectLists_[classID];
     }
+
+    void Context::destroyObjectList(const Identifier* identifier)
+    {
+        ObjectListBase* objectList = this->getObjectList(identifier);
+        delete objectList;
+        this->objectLists_[identifier->getClassID()] = NULL;
+    }
 }
Index: code/trunk/src/libraries/core/object/Context.h
===================================================================
--- code/trunk/src/libraries/core/object/Context.h	(revision 10622)
+++ code/trunk/src/libraries/core/object/Context.h	(revision 10624)
@@ -47,4 +47,5 @@
         public:
             static void setRootContext(Context* context);
+            static void destroyRootContext();
             static Context* getRootContext();
 
@@ -71,4 +72,6 @@
             }
 
+            void destroyObjectList(const Identifier* identifier);
+
         private:
             Context* parentContext_;
Index: code/trunk/src/libraries/core/object/DestroyLaterManager.cc
===================================================================
--- code/trunk/src/libraries/core/object/DestroyLaterManager.cc	(revision 10624)
+++ code/trunk/src/libraries/core/object/DestroyLaterManager.cc	(revision 10624)
@@ -0,0 +1,56 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "DestroyLaterManager.h"
+
+#include "core/CoreIncludes.h"
+#include "core/singleton/ScopedSingletonIncludes.h"
+
+namespace orxonox
+{
+    ManageScopedSingleton(DestroyLaterManager, ScopeID::ROOT, false);
+
+    RegisterAbstractClass(DestroyLaterManager).inheritsFrom<UpdateListener>();
+
+    DestroyLaterManager::DestroyLaterManager()
+    {
+        RegisterObject(DestroyLaterManager);
+    }
+
+    DestroyLaterManager::~DestroyLaterManager()
+    {
+        // Be sure to release all instances
+        this->retainedInstances_.clear();
+    }
+
+    void DestroyLaterManager::postUpdate(const Clock& time)
+    {
+        // clearing the list will destroy all strong pointers and thus all retained instances (as long as there are no other strong pointers pointing to them).
+        this->retainedInstances_.clear();
+    }
+}
